require_relative 'metadata'
require_relative 'mjolnir'
require_relative 'perform'

Thread.abort_on_exception = true


module SourMix
  class Main < Mjolnir
    include Perform
    ONE_HOUR_AGO = (Time.now - 60 * 60).strftime('%Y-%m-%d')


    desc 'version', 'Echo the application version'
    def version
      puts VERSION
    end


    desc 'art', 'View the application art'
    def art
      puts "\n%s\n" % ART
    end


    desc 'go', 'Do your thing, SourMix'
    option :date, \
      type: :string,
      aliases: %w[ -d ],
      desc: 'Date to index (YYYY-mm-dd)',
      required: true,
      default: ENV['SOURMIX_DATE'] || ONE_HOUR_AGO
    option :mixpanel_api_key, \
      type: :string,
      aliases: %w[ -k ],
      desc: 'Mixpanel API key',
      required: true,
      default: ENV['SOURMIX_MIXPANEL_API_KEY']
    option :mixpanel_api_secret, \
      type: :string,
      aliases: %w[ -s ],
      desc: 'Mixpanel API secret',
      required: true,
      default: ENV['SOURMIX_MIXPANEL_API_SECRET']
    option :theon_uri, \
      type: :string,
      aliases: %w[ -t ],
      desc: 'Theon URI (including auth)',
      required: true,
      default: ENV['SOURMIX_THEON_URI']
    include_common_options
    def go
      perform
    end

  end
end
